"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.safeCompare = void 0;
var tslib_1 = require("tslib");
var crypto_1 = tslib_1.__importDefault(require("crypto"));
exports.safeCompare = function (stringA, stringB) {
    var lengthA = Buffer.byteLength(stringA);
    var lengthB = Buffer.byteLength(stringB);
    if (lengthA !== lengthB) {
        return false;
    }
    // Turn strings into buffers with equal length to avoid leaking the length.
    var buffA = Buffer.alloc(lengthA, 0, 'utf8');
    buffA.write(stringA);
    var buffB = Buffer.alloc(lengthB, 0, 'utf8');
    buffB.write(stringB);
    return crypto_1.default.timingSafeEqual(buffA, buffB);
};
